<?php

/**
 * Implementation of hook_vagrant_blueprints
 */
function aegirup_vagrant_blueprints() {
  $blueprints = array(
    'utility' => array(
      'name' => 'Utility',
      'description' => 'A utility server including Git, Jenkins, BIND and Squid servers.',
      'path' => 'blueprints/utility',
      'build_callback' => 'vagrant_default_build',
      ),
    'aegir' => array(
      'name' => 'Aegir',
      'description' => 'An Aegir Hosting System server.',
      'path' => 'blueprints/aegir',
      'build_callback' => 'aegirup_build_project',
    ),
    'aegir-dev' => array(
      'name' => 'Aegir (Dev)',
      'description' => 'An Aegir server installed \'manually\' from Git repos.',
      'path' => 'blueprints/aegir-dev',
      'build_callback' => 'vagrant_default_build',
      ),
    );
  return $blueprints;
}

/**
 * Implementation of hook_drush_command().
 *
 * Req'd for Drush to recognize this file as a Drush extension.
 */
function aegirup_drush_command() {
  $items = array();

  $items['aegirup'] = array(
    'bootstrap' => DRUSH_BOOTSTRAP_DRUSH,
    'hidden' => TRUE,
  );

  return $items;
}

/**
 * Custom drush-vagrant build process to instantiate an existing client project
 */
function aegirup_build_project() {
  $build = vagrant_default_build_vars();
  $build['modules']['dependencies'] = dirname(__FILE__) . '/lib/puppet-modules/';
  vagrant_default_build_project_dir($build);
  // Check for support of 64-bit client OSes
  drush_shell_exec("egrep '(vmx|svm)' /proc/cpuinfo");
  $output = drush_shell_exec_output();

  if (empty($output) || count($output) == 0) {
    $settings_file = file_get_contents($build['project_path'] . '/settings.rb');
    $settings_file = str_replace('debian-LAMP-20', 'debian-LAMP-i386-20', $settings_file);
    $settings_file = str_replace('debian-LAMP-current.box', 'debian-LAMP-i386-current.box', $settings_file);
    file_put_contents($build['project_path'] . '/settings.rb', $settings_file);
  }
  vagrant_default_build_project_setup($build);
  vagrant_default_build_config_dir($build);
  vagrant_default_build_record_blueprint($build);
  vagrant_default_build_user_data($build);
  vagrant_default_build_user_dotfiles($build);
  vagrant_default_build_git_init($build);
}


